Subject: Re: [MMUSIC] I-D Action: draft-ietf-mmusic-msrp-usage-data-channel-11.txt

From: Christer Holmberg <[email-masked]>
Date: Sun, 11 Aug 2019 10:05:03 +0000

Hi,

...

    >> We all agree that the path is not going to be used for routing on the data channel interface.
    >>
    >> But, are the data channel endpoints still going to insert the path(s) in the MSRP messages?
    >
    > I think nothing prevents endpoints to format From-Path and To-Path in 
    > MSRP messages as required by the application, for example, as defined by 
    > RCS specifications.
    
    Sure, but this draft needs to define what the endpoints do.

    > If the other endpoint is not a GW or is a GW acting as B2BUA, those 
    > fields would be processed as defined by MSRP and the application using 
    > the protocol.
    >
    > If the other endpoint is a GW providing transport interworking, there's 
    > no reason for look at MSRP messages. It should be restricted to 
    > transport interworking. How transport is established it's not defined by 
    > the draft, it just says that path attributes should not be used for that 
    > purpose.
    
    Let's forget GWs for a moment, and focus on the data channel. A data channel endpoint does not know whether the peer is a GW, so there needs to be generic procedures.

    >> There's no other scenario, the draft leaves relays out of the scope.
    >>
    >> Currently the draft doesn't say what the path attributes are used for - it only says that they are not used for routing.
    > [Already commented in other message, repeating here so we focus the 
    > conversation on a single thread]
    >
    > How the path attribute is used is defined by RFC4975, section 8.2. ("URI 
    > Negotiations"), that states that the URI is used to determine transport 
    > parameters, protection level and "to identify the target when sending 
    > requests and responses.".
    >
    > As this draft forbids the use of path parameter for transport 
    > establishment, then for data channel transport the URI can only be used 
    > "to identify the target when sending requests and responses.".
    >
    > I believe an implementor can find this, I can add a short paragraph to 
    > clarify in next revision that would essentially replicate what it's 
    > already in RFC4975, what do you think?
    
    We need text that describes how the MSRP messages are created/encoded. We can simply refer to 4975 if that works, but it needs to be clear whether to e.g., use 
    received path attributes and create To/From-paths etc.

    >> Also, section 6 says: "Path attributes SHALL NOT be used for transport level interworking." What is meant by that?
    > My understanding is that it means that the URI fields (IP, port, etc) should not be used for the purposes of establishing the transport 
    > towards the endpoint.
    
    Well, that is not clear to me :)

    Anyway, my suggestion is that we focus on getting the data channel interface text done first, and then we can look at the gateway section.

    It would also be useful to have to XML (or whatever format you use to edit the document) on GitHub, so that one can suggest changes directly without having to explain
    them in e-mails. It is very convenient from my experience :)

    Regards,

    Christer

    > On 18/07/19 17:18, Christer Holmberg wrote:
    >> Hi,
    >>
    >> If think there is a bigger question here, that MAY have to be clarified ietf-mmusic-data-channel-sdpneg:
    >>
    >> To my understanding, the SDP dcsa attribute is used to provide information that is needed to operate the protocol (MSRP in this case) on the data channel - between the data channel endpoints.
    >>
    >> Now, if the data channel peer is a GW, and you need to provide some information (path attributes etc in the case of MSRP) for what happens beyond the GW, is the dcsa attribute really intended for that?
    >>
    >> So, if the data channel peer is an MSRP GW, using legacy MSRP on the "other side", is the dcsa attribute the correct mechanism to provide the GW with whatever information is are needed on the "other side"?
    >>
    >> Regards,
    >>
    >> Christer
    >>
    >>
    >>
    >>
    >>
    >>
    >>
    >>
    >>
    >>
    >>
    >> On 13/07/2019, 15.24, "mmusic on behalf of Makaraju, Raju (Nokia - US/Naperville)" <[email-masked] on behalf of [email-masked]> wrote:
    >>
    >>       >[JM] Draft covers either direct connection to an endpoint or direct connection to a gateway. As middleboxes are out of scope in the connection using >data channel, then CEMA is out of scope. This short explanation currently appears as justification for saying that CEMA is out of scope. I can remove >the explanation and just state that CEMA is out of scope.
    >>       [Raju] I agree with that.
    >>       
    >>       > For example, if the GW is implemented on an SBC, it can use CEMA towars the inside network, using a non-dc transport. But not towards endpoints
    >>       >using data channel transport.
    >>       [Raju] Let's please make this clear in the draft.
    >>       
    >>       >[JM] I agree for RCS should be like that. Would mandating this restrict applicability for other applications?
    >>       [Raju] I agree that such design limitation should only be for RCS (self-imposed), but not for other applications.
    >>       
    >>       Thanks
    >>       Raju
    >>       
    >>       -----Original Message-----
    >>       From: mmusic <[email-masked]> On Behalf Of Jose M Recio
    >>       Sent: Tuesday, July 9, 2019 8:23 AM
    >>       To: [email-masked]
    >>       Subject: Re: [MMUSIC] I-D Action:
    >> draft-ietf-mmusic-msrp-usage-data-channel-11.txt
    >>       
    >>       
    >>       On 9/7/19 10:57 AM, Makaraju, Raju (Nokia - US/Naperville) wrote:
    >>       > Do we need to make any further clarifications for the references to CEMA?
    >>       > Section 5.1.1.2 has a sentence that is a little awkward, but seems to be saying the CEMA is out of scope.
    >>       
    >>       [JM] Draft covers either direct connection to an endpoint or direct connection to a gateway. As middleboxes are out of scope in the connection using data channel, then CEMA is out of scope. This short explanation currently appears as justification for saying that CEMA is out of scope. I can remove the explanation and just state that CEMA is out of scope.
    >>       
    >>       > But in section 6 for gateway function it mentions CEMA can be used.
    >>       
    >>       [JM] Draft supports gateways providing transport level interworking between MSRP endpoints using different transport protocols. CEMA can't be used towards the endpoints using data channel transport, but the GW could use CEMA to interwork with endpoints using other protocols.
    >>       
    >>       For example, if the GW is implemented on an SBC, it can use CEMA towars the inside network, using a non-dc transport. But not towards endpoints using data channel transport.
    >>       
    >>       > My understanding is I think section 6 suggests to use CEMA equivalent procedures without CEMA attributes!
    >>       
    >>       [JM] GW can use CEMA with endpoints using non-dc transports. This can be removed, but I think it would make the GW transport interwork option too restrictive. The B2BUA GW would not be affected.
    >>       
    >>       > Also, in section 6 should we add a further statement that the gateway assumes one MSRP data channel instance and one sub-protocol per SIP dialog as RCS mandates that a single SIP session/dialog has only one MSRP m= line?
    >>       >
    >>       [JM] I agree for RCS should be like that. Would mandating this restrict applicability for other applications?
    >>       
    >>       > Thanks
    >>       > Raju
    >>       >
    >>       >
    >>       > -----Original Message-----
    >>       > From: mmusic <[email-masked]> On Behalf Of
    >>       > [email-masked]
    >>       > Sent: Saturday, June 1, 2019 11:22 PM
    >>       > To: [email-masked]
    >>       > Cc: [email-masked]
    >>       > Subject: [MMUSIC] I-D Action:
    >>       > draft-ietf-mmusic-msrp-usage-data-channel-11.txt
    >>       >
    >>       >
    >>       > A New Internet-Draft is available from the on-line Internet-Drafts directories.
    >>       > This draft is a work item of the Multiparty Multimedia Session Control WG of the IETF.
    >>       >
    >>       >          Title           : MSRP over Data Channels
    >>       >          Authors         : Keith Drage
    >>       >                            Maridi R. Makaraju (Raju)
    >>       >                            Juergen Stoetzer-Bradler
    >>       >                            Richard Ejzak
    >>       >                            Jerome Marcon
    >>       >                            Jose M. Recio
    >>       > 	Filename        : draft-ietf-mmusic-msrp-usage-data-channel-11.txt
    >>       > 	Pages           : 19
    >>       > 	Date            : 2019-06-01
    >>       >
    >>       > Abstract:
    >>       >     This document specifies how the Message Session Relay Protocol (MSRP)
    >>       >     can be instantiated as a data channel sub-protocol, using the SDP
    >>       >     offer/answer exchange-based generic data channel negotiation
    >>       >     framework.  Two network configurations are documented: a WebRTC end-
    >>       >     to-end configuration (connecting two MSRP over data channel
    >>       >     endpoints), and a gateway configuration (connecting an MSRP over data
    >>       >     channel endpoint with an MSRP over TCP or TLS endpoint).
    >>       >
    >>       >
    >>       > The IETF datatracker status page for this draft is:
    >>       > https://datatracker.ietf.org/doc/draft-ietf-mmusic-msrp-usage-data-cha
    >>       > nnel/
    >>       >
    >>       > There are also htmlized versions available at:
    >>       > https://tools.ietf.org/html/draft-ietf-mmusic-msrp-usage-data-channel-
    >>       > 11
    >>       > https://datatracker.ietf.org/doc/html/draft-ietf-mmusic-msrp-usage-dat
    >>       > a-channel-11
    >>       >
    >>       > A diff from the previous version is available at:
    >>       > https://www.ietf.org/rfcdiff?url2=draft-ietf-mmusic-msrp-usage-data-ch
    >>       > annel-11
    >>       >
    >>       >
    >>       > Please note that it may take a couple of minutes from the time of submission until the htmlized version and diff are available at tools.ietf.org.
    >>       >
    >>       > Internet-Drafts are also available by anonymous FTP at:
    >>       > ftp://ftp.ietf.org/internet-drafts/
    >>       >
    >>       > _______________________________________________
    >>       > mmusic mailing list
    >>       > [email-masked]
    >>       > https://www.ietf.org/mailman/listinfo/mmusic
    >>       >
    >>       > _______________________________________________
    >>       > mmusic mailing list
    >>       > [email-masked]
    >>       > https://www.ietf.org/mailman/listinfo/mmusic
    >>       
    >>       _______________________________________________
    >>       mmusic mailing list
    >>       [email-masked]
    >>       https://www.ietf.org/mailman/listinfo/mmusic
    >>       
    >>       _______________________________________________
    >>       mmusic mailing list
    >>       [email-masked]
    >>       https://www.ietf.org/mailman/listinfo/mmusic
    >>       
    >>

---

From: Jose M Recio <[email-masked]>
Date: Wed, 14 Aug 2019 20:07:22 +0800

>      Sure, but this draft needs to define what the endpoints do.
The draft does not need to impose any requirements on how the endpoints 
form the MSRP messages. This is defined by the MSRP RFCs, RCS specs, or 
others.

>      Let's forget GWs for a moment, and focus on the data channel. A data channel endpoint does not know whether the peer is a GW, so there needs to be generic procedures.
What I tried to explain (unsuccesfully) is that MSRP processing is not 
affected in endpoints implementing this draft, it is the same if the 
endpoint is either a gateway or another endpoint.

>      received path attributes and create To/From-paths etc.
I agree with that, I think referring back to 4975 is enough, and it 
would make  behavior more clear.
>      Well, that is not clear to me :)
This is more clear in the new revision with your suggestion on gateway 
procedures, please take a look.

>      them in e-mails. It is very convenient from my experience :)
Agree, I have uploaded the xml document to this github repo:
https://github.com/josemrecio/draft-msrp-data-channel

I have already created a work in progress version 13 with your comments 
on gateway procedures.

---

From: Christer Holmberg <[email-masked]>
Date: Thu, 15 Aug 2019 10:01:01 +0000

Hi,

>    form the MSRP messages. This is defined by the MSRP RFCs, RCS specs, or 
  
You may be right. In the non-gateway case I think the only important thing to point out is the usage of CEMA (see other e-mail).

---
  
>  endpoint is either a gateway or another endpoint.

I agree with that: an MSRP data channel endpoint doesn't need to know whether the peer is an endpoint or a gateway.

---    
    
>>      We need text that describes how the MSRP messages are created/encoded. We can simply 
>>      refer to 4975 if that works, but it needs to be clear whether to e.g., use
>    I agree with that, I think referring back to 4975 is enough, and it would make  behavior more clear.

Yes. I was thinking whether we need to reference CEMA e.g., for URI comparison, but probably not.

I will keep discussions related to gateway in a separate e-mail.

Regards,

Christer